/*
 * File         : Jacobi_h.java
 * Author       : Qiang Zheng
 * Created      : Tue Oct 20 10:23:30 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date:  $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

/* This version use float array, Restart button*/

// package hpjdemo;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import hpjava.spmd.*;
import hpjava.spmd.adlib.*;
import hpjava.lang.*;

public class Jacobi_h extends Frame implements ActionListener {
  static int n=16;
  static int runflag = 1;
  // static int IterNum = 10;
  // static int Clrbase = 1;
  // static float Jcolor[][] = new Float[n][n];

  static JacoGraph jGraphics = new JacoGraph();
  public void init() {
    setFont(new Font("Helvetica", Font.PLAIN, 14));

    Panel pb = new Panel();

    // minputs = new MetroInputs(this);

    pb.setLayout(new GridLayout(10, 1));
    pb.setBackground(Color.orange);

    Button Brst = new Button("Restart");
    Brst.addActionListener(this);
    pb.add(Brst);

    Button Brun = new Button("Run");
    Brun.addActionListener(this);
    pb.add(Brun);

    Button Bstop = new Button("Stop");
    Bstop.addActionListener(this);
    pb.add(Bstop);

    Button Bsmall = new Button("Zoom <<");
    Bsmall.addActionListener(this);
    pb.add(Bsmall);

    Button Blarge = new Button("Zoom >>");
    Blarge.addActionListener(this);
    pb.add(Blarge);

    // Button Bblank = new Button("Blank");
    // pb.add(Bblank);

    Button Bquit = new Button("Quit");
    Bquit.addActionListener(this);
    pb.add(Bquit);

	/* Choice grid = new Choice();
    grid.add("4 * 4");
    grid.add("8 * 8");
    grid.add("16 * 16");
    grid.add("32 * 32");
    grid.addItemListener(new setGridHandler(grid));
    grid.select("8 * 8");
	pb.add(grid); */

    setLayout(new BorderLayout());
    // jGraphics = new JacoGraph();
		jGraphics.init();
    add("Center",jGraphics);
    // add("North",minputs);
    add("West",pb);
  }

  public void actionPerformed(ActionEvent evt) {
		if(evt.getActionCommand() == "Restart") {
		  runflag = 5;
		} else if(evt.getActionCommand() == "Run"){
    	  runflag = 1;
    	} else if(evt.getActionCommand() == "Stop") {
		  runflag = 0;
		} else if(evt.getActionCommand() == "Quit") {
		  runflag = 2;
		} else if(evt.getActionCommand() == "Zoom <<") {
		  runflag = 3;
		} else if(evt.getActionCommand() == "Zoom >>") {
		  runflag = 4;
		} // else if(evt.getActionCommand() == "") {
		  //JacoGraph.setGridSize(4 * (ch.getSelectedIndex() + 1)
          //  ,4 * (ch.getSelectedIndex() + 1));
		  //}
  }

  void update() {
    jGraphics.repaint();
  }

  public static void main(String argv[]) {
    SpmdEnv spmd = new SpmdEnv(argv);
    Procs2 p=new Procs2(2,2);

	  if(p.id() == 0) {
	  	Jacobi_h jtest = new Jacobi_h();
    	jtest.init();
    	jtest.setSize(900, 700);
    	jtest.setLocation(20,30);
    	jtest.show();
	  } 
quit:
    if (p.on()) {
      int [] w = {1,1};

      BlockRange x = new BlockRange (n, p.dim(0), 3, 1, 1);
      BlockRange y = new BlockRange (n, p.dim(1), 3, 1, 1);
      Array2ddF u = new Array2ddF(spmd.apg,x,y);
      Index i = new Index (x);
      Index j = new Index (y);

	  Array2ccF ColorArray_R = new Array2ccF(spmd.apg,n,n);
	  // public Array2ccF ColorArray_G = new Array2ccF(spmd.apg,n,n);
	  // public Array2ccF ColorArray_B = new Array2ccF(spmd.apg,n,n);

      i.dim().over();
      for (i.begin(); i.test(); i.next()) {
          j.dim().over();
          for (j.begin(); j.test(); j.next()) {
            if (x.idx(i)==0 || x.idx(i)==n-1
                  || y.idx(j)==0 || y.idx(j)==n-1)
                u.dat()[u.pos(i, j)]=1;
            else
                u.dat()[u.pos(i, j)]=0;
          } j.dim().revo();
      } i.dim().revo();

      Array2ddF uold = new Array2ddF(spmd.apg,x, y) ;
      Index ic = new Index (x.subrng(n-2, 1));
      Index jc = new Index (y.subrng(n-2, 1));
stop:
        while(true) {
			if (runflag == 5) {
				for (int k = 0; k < n; k++) {
					for (int l = 0; l < n; l++) {
						if(k == 0 || k == n-1 || l == 0 || l == n-1)
							ColorArray_R.dat()[ColorArray_R.pos(k,l)] = 1;
						else
							ColorArray_R.dat()[ColorArray_R.pos(k,l)] = 0;
					}
				}
				Adlib.remap(u,ColorArray_R);
				runflag = 1;
				// continue stop;
			} else if(runflag == 0) { 
				continue stop;
			} else if(runflag == 2) {
				break quit;
			} else if(runflag == 3) {
				jGraphics.setRectSize(jGraphics.currentRectSize() / 2);
				jGraphics.repaint();
				runflag = 1;
			} else if(runflag == 4) {
				jGraphics.setRectSize(jGraphics.currentRectSize() * 2);
				jGraphics.repaint();
				runflag = 1;
			} else if(runflag == 1){
        	//for (int iter=0; iter < IterNum; iter++) {}
            Adlib.copy(uold, u);
            //static public void copy(SectionI dst, SectionI src)
            Adlib.writeHalo(uold,w,w);
            // static public void writeHalo(Section src, int[] wlo, int[] whi)
            ic.dim().over();
            for (ic.begin(); ic.test(); ic.next()) {
                jc.dim().over();
                for (jc.begin(); jc.test(); jc.next()) {
                    u.dat()[u.pos(ic,jc)]
                        = (float) 0.25 * (uold.dat()[uold.pos(ic.shift(-1),jc)]+
                            uold.dat()[uold.pos(ic.shift(1),jc)]+
                            uold.dat()[uold.pos(ic,jc.shift(-1))]+
                            uold.dat()[uold.pos(ic,jc.shift(1))]);
                } jc.dim().revo();
            } ic.dim().revo();
            //Adlib.rprintln("iteration = "+iter);
            //Adlib.aprintf("%7.3f%"+n+"N", u);
            Adlib.remap(ColorArray_R,u);
			jGraphics.setClr(ColorArray_R.dat());
            jGraphics.repaint();
			}
      } //end of while loop
      // Adlib.aprintf("%7.3f%"+n+"N", u);
    } p.no();

    spmd.finalize();
  }

  public void draw()
  {
	jGraphics.repaint();
  }

}

class setGridHandler implements ItemListener {
    private Choice ch;

    public setGridHandler(Choice c) {ch = c;}
    public void itemStateChanged(ItemEvent e)
    {
        JacoGraph.setGridSize(4 * (ch.getSelectedIndex() + 1)
            ,4 * (ch.getSelectedIndex() + 1));
        // JacoGraph.repaint();
    }
}
